      PROGRAM CASMAIN
      Implicit None
c	Integer N1,N2
	Integer K1,K2,LUX
#include "casluco.inc"
#include "casparas.inc"
#include "casvalues.inc"
      Integer IGLU
	Common/CAGLUON/Iglu

      Integer ISEED,I
	
	Integer Nevent
	Common/steer1/Nevent
	
	real timeleft
	Integer Minuts
	External Minuts
	Integer irr
	Logical ex
	
      ISEED = Iabs(MINUTS())
	ISEED = 47034466
C initialize random number generator	
c      n1=0
c      n2=0
c      CALL RM48IN(ISEED,N1,N2)
c      LUX = 3
      LUX = 4
      K1=0
      K2=0
      CALL RLUXGO(LUX,ISEED,K1,K2)
C initialise PYTHIA 6 parameters, now done via block data
C initialise CASCADE parameters
      CALL CASINI

      CALL STEER
	
C-- change standard parameters of CASCADE
	Call cascha
c
C-- change standard parameters of JETSET/PYTHIA
      Call pytcha
c      call pylogo
c
c Start integration of x-section
c
      CALL PTIME(' cascade  ',1,0)
	   call timel(timeleft)
C	   write(6,*) 'timeleft ',timeleft

      CALL CASCADE
c
c Print out result of integration of x-section
c
      CALL CAEND(1)
	
c	inquire(FILE='pythia62.dat',EXIST=ex)
c       if(ex) then
c         open(3,FILE='pythia62.dat', FORM='formatted',STATUS='OLD',
c     +   IOSTAT=IRR,ERR=220)
c         write(6,*) ' updating PYTHIA particle data with file ' 
c	   call pyupda(3,3)
c      else 
c         write(6,*) '  PYTHIA particle data file not existing ' 
c         open(3,FILE='pythia62.dat', FORM='formatted',STATUS='NEW',
c     +   IOSTAT=IRR,ERR=220)
c	   call pyupda(1,3)
c	Endif
c
c Start event loop
c
c	pause
      Do I=1,max(10,Nevent)
         CALL PTIME(' event  ',1,0)
	   call timel(timeleft)
c	   write(6,*) ' casmain: timeleft: ',timeleft
c	   if(timeleft.le.10.) goto 123
c generate an event
         CALL EVENT
c	   write(6,*) ' after event '
C--- user analysis routine (hztool)
cccc         CALL hzcaana
c	   write(6,*) ' after hztool '
         CALL PTIME(' event  ',2,0)
      Enddo
123   Continue
c
c Print out of generated events summary
c
      CALL CAEND(20)
C--- user terminate routine (hztool)
ccc      CALL hzcaend
      CALL PTIME(' cascade  ',2,0)
      CALL PTIME('        ',2,99)
	
      STOP
  220 write(6,*) ' error opening  file for PYTHIA update '
      STOP
      END


#include "pydata.f"
